(function(){"use strict";var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor}}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function")}}var rules=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([a-zA-Z0-9-_.~]+)/},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:function regex(match){return new RegExp(";"+match[1]+"=([a-zA-Z0-9-_.~]+)")}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function regex(match){return new RegExp(match[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function regex(match){return new RegExp(match[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function regex(match){return new RegExp(match[0])}}];var tokenise=function tokenise(str){var tokens=arguments[1]===undefined?[]:arguments[1];var matched=rules.some(function(rule){var match=str.match(rule.pattern);if(!match)return false;tokens.push({type:rule.name,match:match[0],val:match.length>1?match.slice(1):null,regex:rule.regex instanceof Function?rule.regex(match):rule.regex});if(match[0].length<str.length)tokens=tokenise(str.substr(match[0].length),tokens);return true});if(!matched){throw new Error("Could not parse path.")}return tokens};var Path=function(){function Path(path){_classCallCheck(this,Path);if(!path)throw new Error("Please supply a path");this.path=path;this.tokens=tokenise(path);this.hasUrlParams=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(t){return/splat$/.test(t.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(t){return/matrix$/.test(t.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(t){return t.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).map(function(t){return t.val}).reduce(function(r,v){return r.concat(v)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(t){return t.type==="query-parameter"}).map(function(t){return t.val}).reduce(function(r,v){return r.concat(v)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(t){return t.regex!==undefined}).map(function(r){return r.regex.source}).join("")}_createClass(Path,[{key:"_urlMatch",value:function _urlMatch(path,regex){var _this=this;var match=path.match(regex);if(!match)return null;else if(!this.urlParams.length)return{};return match.slice(1,this.urlParams.length+1).reduce(function(params,m,i){params[_this.urlParams[i]]=m;return params},{})}},{key:"match",value:function match(path){var _this2=this;var match=this._urlMatch(path,new RegExp("^"+this.source+(this.hasQueryParams?"?.*$":"$")));if(!match||!this.hasQueryParams)return match;var queryParams=path.split("?")[1].split("&").map(function(_){return _.split("=")}).reduce(function(obj,m){obj[m[0]]=m[1];return obj},{});if(Object.keys(queryParams).every(function(p){return Object.keys(_this2.queryParams).indexOf(p)!==1})&&Object.keys(queryParams).length===this.queryParams.length){Object.keys(queryParams).forEach(function(p){return match[p]=queryParams[p]});return match}return null}},{key:"partialMatch",value:function partialMatch(path){return this._urlMatch(path,new RegExp("^"+this.source))}},{key:"build",value:function build(){var params=arguments[0]===undefined?{}:arguments[0];if(!this.params.every(function(p){return params[p]!==undefined}))throw new Error("Missing parameters");var base=this.tokens.filter(function(t){return t.type!=="query-parameter"}).map(function(t){if(t.type==="url-parameter-matrix")return";"+t.val[0]+"="+params[t.val[0]];return/^url-parameter/.test(t.type)?params[t.val[0]]:t.match}).join("");var searchPart=this.queryParams.map(function(p){return p+"="+params[p]}).join("&");return base+(searchPart?"?"+searchPart:"")}}]);return Path}();var RouteNode=function(){function RouteNode(){var name=arguments[0]===undefined?"":arguments[0];var path=arguments[1]===undefined?"":arguments[1];var childRoutes=arguments[2]===undefined?[]:arguments[2];_classCallCheck(this,RouteNode);this.name=name;this.path=path;this.parser=path?new Path(path):null;this.children=[];this.add(childRoutes);return this}_createClass(RouteNode,[{key:"add",value:function add(route){var _this=this;if(route instanceof Array){route.forEach(function(r){return _this.add(r)});return}if(!(route instanceof RouteNode)&&!(route instanceof Object)){throw new Error("Route constructor expects routes to be an Object or an instance of Route.")}if(route instanceof Object){if(!route.name||!route.path){throw new Error("Route constructor expects routes to have an name and a path defined.")}route=new RouteNode(route.name,route.path,route.children)}if(this.children.map(function(child){return child.name}).indexOf(route.name)!==-1){throw new Error('Alias "'+route.name+'" is already defined in route node')}if(this.children.map(function(child){return child.path}).indexOf(route.path)!==-1){throw new Error('Path "'+route.path+'" is already defined in route node')}var names=route.name.split(".");if(names.length===1){this.children.push(route);this.children.sort(function(childA,childB){return childA.hasSplatParam?-1:1})}else{var segments=this.getSegmentsByName(names.slice(0,-1).join("."));if(segments){segments[segments.length-1].add(new RouteNode(names[names.length-1],route.path,route.children))}else{throw new Error("Could not add route named '"+route.name+"', parent is missing.")}}return this}},{key:"addNode",value:function addNode(name,params){this.add(new RouteNode(name,params));return this}},{key:"getSegmentsByName",value:function getSegmentsByName(routeName){var findSegmentByName=function findSegmentByName(name,routes){var filteredRoutes=routes.filter(function(r){return r.name===name});return filteredRoutes.length?filteredRoutes[0]:undefined};var segments=[];var names=routeName.split(".");var routes=this.children;var matched=names.every(function(name){var segment=findSegmentByName(name,routes);if(segment){routes=segment.children;segments.push(segment);return true}return false});return matched?segments:null}},{key:"getSegmentsMatchingPath",value:function getSegmentsMatchingPath(path){var matchChildren=function matchChildren(nodes,pathSegment,segments){var _loop=function(i){var child=nodes[i];var match=child.parser.partialMatch(pathSegment);if(match){segments.push(child);Object.keys(match).forEach(function(param){return segments.params[param]=match[param]});var remainingPath=pathSegment.replace(child.parser.build(match),"");if(!remainingPath.length){return{v:segments}}if(!child.children.length){return{v:null}}return{v:matchChildren(child.children,remainingPath,segments)}}};for(var i in nodes){var _ret=_loop(i);if(typeof _ret==="object")return _ret.v}return null};var startingNodes=this.parser?[this]:this.children;var segments=[];segments.params={};return matchChildren(startingNodes,path,segments)}},{key:"getPathFromSegments",value:function getPathFromSegments(segments){return segments?segments.map(function(segment){return segment.path}).join(""):null}},{key:"getPath",value:function getPath(routeName){return this.getPathFromSegments(this.getSegmentsByName(routeName))}},{key:"buildPathFromSegments",value:function buildPathFromSegments(segments){var params=arguments[1]===undefined?{}:arguments[1];return segments?segments.map(function(segment){return segment.parser.build(params)}).join(""):null}},{key:"buildPath",value:function buildPath(routeName){var params=arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(routeName),params)}},{key:"getMatchPathFromSegments",value:function getMatchPathFromSegments(segments){if(!segments)return null;var name=segments.map(function(segment){return segment.name}).join(".");var params=segments.params;return{name:name,params:params}}},{key:"matchPath",value:function matchPath(path){return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(path))}}]);return RouteNode}();"use strict";var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor}}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function")}}var nameToIDs=function nameToIDs(name){return name.split(".").reduce(function(ids,name){ids.push(ids.length?ids[ids.length-1]+"."+name:name);return ids},[])};var makeState=function makeState(name,params,path){return{name:name,params:params,path:path}};var Router5=function(){function Router5(routes){var opts=arguments[1]===undefined?{}:arguments[1];_classCallCheck(this,Router5);this.started=false;this.callbacks={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=routes instanceof RouteNode?routes:new RouteNode("","",routes);this.activeComponents={};this.options=opts;return this}_createClass(Router5,[{key:"setOption",value:function setOption(opt,val){this.options[opt]=val;return this}},{key:"add",value:function add(routes){this.rootNode.add(routes);return this}},{key:"addNode",value:function addNode(name,params){this.rootNode.addNode(name,params);return this}},{key:"onPopState",value:function onPopState(evt){if(!evt.state)return;if(this.lastKnownState&&this.areStatesEqual(evt.state,this.lastKnownState))return;var canTransition=this._transition(evt.state,this.lastKnownState);if(canTransition)this.lastKnownState=evt.state}},{key:"start",value:function start(){if(this.started)return this;this.started=true;var startPath=this.options.useHash?window.location.hash.replace(/^#/,""):window.location.pathname;var startMatch=this.rootNode.matchPath(startPath);if(startMatch){this.lastKnownState=makeState(startMatch.name,startMatch.params,startPath);window.history.replaceState(this.lastKnownState,"",this.options.useHash?"#"+startPath:startPath)}else if(this.options.defaultRoute){this.navigate(this.options.defaultRoute,this.options.defaultParams,{replace:true})}window.addEventListener("popstate",this.onPopState.bind(this));return this}},{key:"stop",value:function stop(){if(!this.started)return this;this.started=false;window.removeEventListener("popstate",this.onPopState.bind(this));return this}},{key:"_invokeCallbacks",value:function _invokeCallbacks(name,newState,oldState){var _this=this;if(!this.callbacks[name])return;this.callbacks[name].forEach(function(cb){cb.call(_this,newState,oldState)})}},{key:"_transition",value:function _transition(toState,fromState){var _this2=this;var cannotDeactivate=false;if(fromState){var i=undefined;var fromStateIds=nameToIDs(fromState.name);var toStateIds=nameToIDs(toState.name);var maxI=Math.min(fromStateIds.length,toStateIds.length);for(i=0;i<maxI;i+=1){if(fromStateIds[i]!==toStateIds[i])break}cannotDeactivate=fromStateIds.slice(i).reverse().map(function(id){return _this2.activeComponents[id]}).filter(function(comp){return comp&&comp.canDeactivate}).some(function(comp){return!comp.canDeactivate(toState,fromState)});if(!cannotDeactivate&&i>0)this._invokeCallbacks(fromStateIds[i-1],toState,fromState)}if(!cannotDeactivate)this._invokeCallbacks("",toState,fromState);return!cannotDeactivate}},{key:"getState",value:function getState(){return this.lastKnownState}},{key:"areStatesEqual",value:function areStatesEqual(state1,state2){return state1.name===state2.name&&Object.keys(state1.params).length===Object.keys(state2.params).length&&Object.keys(state1.params).every(function(p){return state1.params[p]===state2.params[p]})}},{key:"registerComponent",value:function registerComponent(name,component){if(this.activeComponents[name])console.warn("A component was alread registered for route node "+name+".");this.activeComponents[name]=component}},{key:"deregisterComponent",value:function deregisterComponent(name){delete this.activeComponents[name]}},{key:"addNodeListener",value:function addNodeListener(name,cb){if(name){var segments=this.rootNode.getSegmentsByName(name);if(!segments)console.warn("No route found for "+name+", listener could be never called!")}if(!this.callbacks[name])this.callbacks[name]=[];this.callbacks[name].push(cb)}},{key:"removeNodeListener",value:function removeNodeListener(name,cb){if(!this.callbacks[name])return;this.callbacks[name]=this.callbacks[name].filter(function(callback){return callback!==cb})}},{key:"addListener",value:function addListener(cb){this.addNodeListener("",cb)}},{key:"removeListener",value:function removeListener(cb){this.removeNodeListener("",cb)}},{key:"buildPath",value:function buildPath(route,params){return(this.options.useHash?"#":"")+this.rootNode.buildPath(route,params)}},{key:"navigate",value:function navigate(name){var params=arguments[1]===undefined?{}:arguments[1];var opts=arguments[2]===undefined?{}:arguments[2];if(!this.started)return;var path=this.rootNode.buildPath(name,params);if(!path)throw new Error('Could not find route "'+name+'"');this.lastStateAttempt=makeState(name,params,path);var sameStates=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(sameStates&&!opts.reload)return;var canTransition=this._transition(this.lastStateAttempt,this.lastKnownState);if(canTransition&&!sameStates){window.history[opts.replace?"replaceState":"pushState"](this.lastStateAttempt,"",this.options.useHash?"#"+path:path)}if(canTransition){this.lastKnownState=this.lastStateAttempt}}}]);return Router5}();window.RouteNode=RouteNode;window.Router5=Router5})();